#ifndef BINARY_SEARCH_TREE_H
#define BINARY_SEARCH_TREE_H

#include "Node.h"

class BinarySearchTree {
public:
  BinarySearchTree();
  ~BinarySearchTree();

  bool add(int key, int type, unsigned int len, void *data);
  bool remove(int key);
  bool write(int key, int type, unsigned int len, void *data);
  bool read(int key, int *type, unsigned int *len, void *data);
  std::vector<int> find(unsigned int len, void *data);

  std::vector<int> getKeys();
  void printKeys();

private:
  Node *root_;

  void getNodeKey(Node *node, std::vector<int> *keys);
  void getNodeWithDataKey(Node *node, std::vector<int> *keys, unsigned int len,
                          void *data);
  void printNode(Node *node);
  bool findNode(int key, Node **node, Node **parent);
};

#endif // BINARY_SEARCH_TREE_H