#ifndef NODE_H
#define NODE_H

#include <cstring>
#include <iostream>
#include <vector>

#include "DataTypes.h"

class Node {
public:
  Node(int key, int dataTypeID, unsigned int len, void *data);
  Node(int key);
  ~Node();

  bool operator==(const Node &node);
  bool operator!=(const Node &node);
  bool operator>(const Node &node);
  bool operator<(const Node &node);

  bool hasLeftChild();
  Node *getLeftChild();
  void setLeftChild(Node *node);

  bool hasRightChild();
  Node *getRightChild();
  void setRightChild(Node *node);

  int getKey();

  void setData(int type, void *data);
  void getData(int *type, unsigned int *len, void *data);

private:
  int key_;

  Node *lChild_;
  Node *rChild_;

  int dataTypeID_;
  unsigned int data_length_;
  void *data_;
};

#endif // NODE_H