#include "Node.h"

Node::Node(int key, int type, unsigned int len, void *data) {
  key_ = key;
  lChild_ = nullptr;
  rChild_ = nullptr;

  data_length_ = len;
  setData(type, data);
}

Node::Node(int key) {
  key_ = key;
  lChild_ = nullptr;
  rChild_ = nullptr;
  data_length_ = 18;
  dataTypeID_ = -1;
  data_ = nullptr;

  char *data = new char[18];
  std::memcpy(data, "NO DATA SPECIFIED!", 18);
  setData(-1, &(data)[0]);
  delete[] data;
}

Node::~Node() {
  if (data_) {
    delete[](char *) data_;
  }
  if (lChild_) {
    delete lChild_;
  }
  if (rChild_) {
    delete rChild_;
  }
}

bool Node::operator==(const Node &node) { return key_ == node.key_; }

bool Node::operator!=(const Node &node) { return key_ != node.key_; }

bool Node::operator>(const Node &node) { return key_ > node.key_; }

bool Node::operator<(const Node &node) { return key_ < node.key_; }

bool Node::hasLeftChild() { return lChild_ != nullptr; }

Node *Node::getLeftChild() { return lChild_; }

void Node::setLeftChild(Node *node) { lChild_ = node; }

bool Node::hasRightChild() { return rChild_ != nullptr; }

Node *Node::getRightChild() { return rChild_; }

void Node::setRightChild(Node *node) { rChild_ = node; }

int Node::getKey() { return key_; }

void Node::setData(int type, void *data) {
  dataTypeID_ = type;
  
  if (data) {
    data_ = (void *)new char[data_length_];
    std::memcpy(data_, data, data_length_);
  }
}

void Node::getData(int *type, unsigned int *len, void *data) {
  if (type) {
    *type = dataTypeID_;
  }
  if (len) {
    *len = data_length_;
  }
  if (data) {
    std::memcpy(data, data_, data_length_);
  }
}
